Attribute VB_Name = "format_function"
Public Function f(temp As Variant, width, dp As Integer) As String

'=================================================================================='
'=                                                                                ='
'=    format_function                                                             ='
'=                                                                                ='
'=    Function to format outputs to file in a manner akin to Fortran              ='
'=    Part of the program SDC Direct Impacts                                      ='
'=                                                                                ='
'=    Author: Paul Williamson, Dept of Geography, University of Liverpool         ='
'=                                                                                ='
'=    Copyright Paul Williamson 2005                                              ='
'=                                                                                ='
'=    This program is free software; you can redistribute it and/or modify        ='
'=    it under the terms of the GNU General Public License as published by        ='
'=    the Free Software Foundation; either version 2 of the License, or           ='
'=    (at your option) any later version.                                         ='
'=                                                                                ='
'=    This program is distributed in the hope that it will be useful,             ='
'=    but WITHOUT ANY WARRANTY; without even the implied warranty of              ='
'=    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ='
'=    GNU General Public License for more details.                                ='
'=                                                                                ='
'=    You should have received a copy of the GNU General Public License           ='
'=    along with this program; if not, write to the Free Software                 ='
'=    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA  ='
'=                                                                                ='
'=================================================================================='

Dim i As Integer

Dim whole, fmt, tmpf As String

For i = 1 To width
  whole = whole + "@"
Next i

For i = 1 To width - dp - 1 - 1
 fmt = fmt + "#"
Next i

If (dp > 0) Then
  fmt = fmt + "0."
Else
  fmt = fmt + "#0."
End If

For i = 1 To dp
  fmt = fmt + "0"
Next i

tmpf = Format(CStr(Format(temp, fmt)), whole)

'Print #outfile, temp, fmt, whole, tmpf

If (dp > 0) Then
  If ((Len(tmpf)) > width) Then
    For i = 1 To width
      f = f + "#"
    Next i
  Else
      f = tmpf
  End If
ElseIf (dp = 0) Then
  If ((Len(tmpf)) > width + 1) Then
    For i = 1 To width
      f = f + "#"
    Next i
  ElseIf ((Len(tmpf)) = (width + 1)) Then
    f = Left(tmpf, width)
  Else
    f = " " + Left(tmpf, width - 1)
  End If
End If


End Function
